import junit.framework.Assert;
import org.junit.Test;

import java.util.Arrays;

import static org.junit.Assert.*;

public class ArrazTest {

    private int[] spiffyHandyIntArray = new int[] {4,5,102,6,-7,12,-32,92,8};

    private double[] spiffyHandyDoubleArray = new double[] {1.0, 0.5, 3.6, 38.4, 17.3, 62.0, 9.0, 3.375, 0, 3.14159};

    Arraz whySoDifficult = new Arraz();

    @Test
    public void sumValuesOfArray() {

        int sum = 190;

        Assert.assertEquals(sum, Arraz.sumValuesOfArray(spiffyHandyIntArray));

    }

    @Test
    public void sumDoublesOfArray() {

        double sum = 138.31659000000002;

        Assert.assertEquals(sum, Arraz.sumDoublesOfArray(spiffyHandyDoubleArray));

    }

    @Test
    public void averageOfArray() {

        int average = 21;

        Assert.assertEquals(average, Arraz.averageOfArray(spiffyHandyIntArray));

    }

    @Test
    public void doubleAverageOfArray() {

        double average = 13.831659000000002;

        Assert.assertEquals(average, Arraz.doubleAverageOfArray(spiffyHandyDoubleArray));

    }

    @Test
    public void containsValue() {

        Assert.assertTrue(Arraz.containsValue(spiffyHandyIntArray, 102));
        Assert.assertFalse(Arraz.containsValue(spiffyHandyIntArray, 103));

    }


    @Test
    public void reverseArray() {

        int[] expected = new int[] {8, 92, -32, 12, -7, 6, 102, 5, 4};

        Assert.assertEquals(Arrays.toString(expected), Arrays.toString(Arraz.reverseArray(spiffyHandyIntArray)));

    }

    @Test
    public void getOddEvensOfArray() {

        OddEven result = new OddEven(2, 7);

        Assert.assertEquals(result.odds, Arraz.getOddEvensOfArray(spiffyHandyIntArray).odds);
        Assert.assertEquals(result.evens, Arraz.getOddEvensOfArray(spiffyHandyIntArray).evens);

    }

    @Test
    @SuppressWarnings("unchecked")
    public void findIndexOf() {

        //Given
        int expected = 4;
        int expectedtwo = -1;
        int val = -7;
        int valtwo = 123456789;
        Integer[] damnedObjects = new Integer[] {4,5,102,6,-7,12,-32,92,8};

        //Assert
        Assert.assertEquals(expected, whySoDifficult.findIndexOf(damnedObjects, val));
        Assert.assertEquals(expectedtwo, whySoDifficult.findIndexOf(damnedObjects, valtwo));

    }

    @Test
    public void copyArrayByIterator() {
    }

    @Test
    public void copyArrayByLoop() {
    }
}